<html>
<head>
<title>OgreMatrix3.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreMatrix3.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreMatrix3_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Matrix3_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Matrix3_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// NB All code adapted from Wild Magic 0.2 Matrix math (free source code)</span>
<a name="l00036"></a>00036 <span class="comment">// http://www.geometrictools.com/</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// NOTE.  The (x,y,z) coordinate system is assumed to be right-handed.</span>
<a name="l00039"></a>00039 <span class="comment">// Coordinate axis rotation matrices are of the form</span>
<a name="l00040"></a>00040 <span class="comment">//   RX =    1       0       0</span>
<a name="l00041"></a>00041 <span class="comment">//           0     cos(t) -sin(t)</span>
<a name="l00042"></a>00042 <span class="comment">//           0     sin(t)  cos(t)</span>
<a name="l00043"></a>00043 <span class="comment">// where t &gt; 0 indicates a counterclockwise rotation in the yz-plane</span>
<a name="l00044"></a>00044 <span class="comment">//   RY =  cos(t)    0     sin(t)</span>
<a name="l00045"></a>00045 <span class="comment">//           0       1       0</span>
<a name="l00046"></a>00046 <span class="comment">//        -sin(t)    0     cos(t)</span>
<a name="l00047"></a>00047 <span class="comment">// where t &gt; 0 indicates a counterclockwise rotation in the zx-plane</span>
<a name="l00048"></a>00048 <span class="comment">//   RZ =  cos(t) -sin(t)    0</span>
<a name="l00049"></a>00049 <span class="comment">//         sin(t)  cos(t)    0</span>
<a name="l00050"></a>00050 <span class="comment">//           0       0       1</span>
<a name="l00051"></a>00051 <span class="comment">// where t &gt; 0 indicates a counterclockwise rotation in the xy-plane.</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="keyword">namespace </span>Ogre
<a name="l00054"></a>00054 {
<a name="l00068"></a><a class="code" href="classOgre_1_1Matrix3.html">00068</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>
<a name="l00069"></a>00069     {
<a name="l00070"></a>00070     <span class="keyword">public</span>:
<a name="l00075"></a><a class="code" href="classOgre_1_1Matrix3.html#a0ecaa32a22cc18ca76dc74377005e7e1">00075</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Matrix3.html#a0ecaa32a22cc18ca76dc74377005e7e1" title="Default constructor.">Matrix3</a> () {}
<a name="l00076"></a><a class="code" href="classOgre_1_1Matrix3.html#a705a22877d9f0a33724887e577486b41">00076</a>         <span class="keyword">inline</span> <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> (<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> arr[3][3])
<a name="l00077"></a>00077         {
<a name="l00078"></a>00078             memcpy(m,arr,9*<span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>));
<a name="l00079"></a>00079         }
<a name="l00080"></a><a class="code" href="classOgre_1_1Matrix3.html#a04f1bcba696c41cae099b5229789772b">00080</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix)
<a name="l00081"></a>00081         {
<a name="l00082"></a>00082             memcpy(m,rkMatrix.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>,9*<span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>));
<a name="l00083"></a>00083         }
<a name="l00084"></a><a class="code" href="classOgre_1_1Matrix3.html#a3653fb657419f82d71f7ae06df0dd9f5">00084</a>         <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry00, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry01, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry02,
<a name="l00085"></a>00085                     <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry10, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry11, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry12,
<a name="l00086"></a>00086                     <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry20, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry21, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fEntry22)
<a name="l00087"></a>00087         {
<a name="l00088"></a>00088             m[0][0] = fEntry00;
<a name="l00089"></a>00089             m[0][1] = fEntry01;
<a name="l00090"></a>00090             m[0][2] = fEntry02;
<a name="l00091"></a>00091             m[1][0] = fEntry10;
<a name="l00092"></a>00092             m[1][1] = fEntry11;
<a name="l00093"></a>00093             m[1][2] = fEntry12;
<a name="l00094"></a>00094             m[2][0] = fEntry20;
<a name="l00095"></a>00095             m[2][1] = fEntry21;
<a name="l00096"></a>00096             m[2][2] = fEntry22;
<a name="l00097"></a>00097         }
<a name="l00098"></a>00098 
<a name="l00101"></a><a class="code" href="classOgre_1_1Matrix3.html#a741fc44c8d8a16de7eb395209d025f5c">00101</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">swap</a>(<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; other)
<a name="l00102"></a>00102         {
<a name="l00103"></a>00103             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[0][0], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[0][0]);
<a name="l00104"></a>00104             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[0][1], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[0][1]);
<a name="l00105"></a>00105             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[0][2], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[0][2]);
<a name="l00106"></a>00106             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[1][0], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[1][0]);
<a name="l00107"></a>00107             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[1][1], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[1][1]);
<a name="l00108"></a>00108             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[1][2], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[1][2]);
<a name="l00109"></a>00109             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[2][0], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[2][0]);
<a name="l00110"></a>00110             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[2][1], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[2][1]);
<a name="l00111"></a>00111             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(m[2][2], other.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>[2][2]);
<a name="l00112"></a>00112         }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114         <span class="comment">// member access, allows use of construct mat[r][c]</span>
<a name="l00115"></a><a class="code" href="classOgre_1_1Matrix3.html#ad5ae794f77955d57e92f0457bcdf0d0b">00115</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* operator[] (<span class="keywordtype">size_t</span> iRow)<span class="keyword"> const</span>
<a name="l00116"></a>00116 <span class="keyword">        </span>{
<a name="l00117"></a>00117             <span class="keywordflow">return</span> (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>*)m[iRow];
<a name="l00118"></a>00118         }
<a name="l00119"></a>00119         <span class="comment">/*inline operator Real* ()</span>
<a name="l00120"></a>00120 <span class="comment">        {</span>
<a name="l00121"></a>00121 <span class="comment">            return (Real*)m[0];</span>
<a name="l00122"></a>00122 <span class="comment">        }*/</span>
<a name="l00123"></a>00123         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> GetColumn (<span class="keywordtype">size_t</span> iCol) <span class="keyword">const</span>;
<a name="l00124"></a>00124         <span class="keywordtype">void</span> SetColumn(<span class="keywordtype">size_t</span> iCol, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; vec);
<a name="l00125"></a>00125         <span class="keywordtype">void</span> FromAxes(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; xAxis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; yAxis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; zAxis);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127         <span class="comment">// assignment and comparison</span>
<a name="l00128"></a><a class="code" href="classOgre_1_1Matrix3.html#af1d37de5c682f78870aae007ee71a360">00128</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix)
<a name="l00129"></a>00129         {
<a name="l00130"></a>00130             memcpy(m,rkMatrix.<a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">m</a>,9*<span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>));
<a name="l00131"></a>00131             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133 
<a name="l00136"></a>00136         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator== </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix) <span class="keyword">const</span>;
<a name="l00137"></a>00137 
<a name="l00140"></a><a class="code" href="classOgre_1_1Matrix3.html#ac28de07a8eeb9257d9f6a85c8bf9a0df">00140</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix)<span class="keyword"> const</span>
<a name="l00141"></a>00141 <span class="keyword">        </span>{
<a name="l00142"></a>00142             <span class="keywordflow">return</span> !<a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(rkMatrix);
<a name="l00143"></a>00143         }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145         <span class="comment">// arithmetic operations</span>
<a name="l00148"></a>00148 <span class="comment"></span>        <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> operator+ (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix) <span class="keyword">const</span>;
<a name="l00149"></a>00149 
<a name="l00152"></a>00152         <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> operator- (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix) <span class="keyword">const</span>;
<a name="l00153"></a>00153 
<a name="l00156"></a>00156         <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix) <span class="keyword">const</span>;
<a name="l00157"></a>00157         <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> operator- () <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00160"></a>00160         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector) <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00163"></a>00163         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector,
<a name="l00164"></a>00164             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix);
<a name="l00165"></a>00165 
<a name="l00167"></a>00167         <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar) <span class="keyword">const</span>;
<a name="l00168"></a>00168 
<a name="l00170"></a>00170         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkMatrix);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172         <span class="comment">// utilities</span>
<a name="l00173"></a>00173         <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> Transpose () <span class="keyword">const</span>;
<a name="l00174"></a>00174         <span class="keywordtype">bool</span> Inverse (<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkInverse, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fTolerance = 1e-06) <span class="keyword">const</span>;
<a name="l00175"></a>00175         <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> Inverse (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fTolerance = 1e-06) <span class="keyword">const</span>;
<a name="l00176"></a>00176         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Determinant () <span class="keyword">const</span>;
<a name="l00177"></a>00177 
<a name="l00178"></a>00178         <span class="comment">// singular value decomposition</span>
<a name="l00179"></a>00179         <span class="keywordtype">void</span> SingularValueDecomposition (<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkL, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkS,
<a name="l00180"></a>00180             <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkR) <span class="keyword">const</span>;
<a name="l00181"></a>00181         <span class="keywordtype">void</span> SingularValueComposition (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkL,
<a name="l00182"></a>00182             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkS, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkR);
<a name="l00183"></a>00183 
<a name="l00185"></a>00185         <span class="keywordtype">void</span> Orthonormalize ();
<a name="l00186"></a>00186 
<a name="l00188"></a>00188         <span class="keywordtype">void</span> QDUDecomposition (<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkQ, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkD,
<a name="l00189"></a>00189             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkU) <span class="keyword">const</span>;
<a name="l00190"></a>00190 
<a name="l00191"></a>00191         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> SpectralNorm () <span class="keyword">const</span>;
<a name="l00192"></a>00192 
<a name="l00193"></a>00193         <span class="comment">// matrix must be orthonormal</span>
<a name="l00194"></a>00194         <span class="keywordtype">void</span> ToAngleAxis (<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfAngle) <span class="keyword">const</span>;
<a name="l00195"></a><a class="code" href="classOgre_1_1Matrix3.html#afb91aa65a30bd4dda455117851bc9cc4">00195</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Matrix3.html#afb91aa65a30bd4dda455117851bc9cc4">ToAngleAxis</a> (<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis, <a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>&amp; rfAngle)<span class="keyword"> const </span>{
<a name="l00196"></a>00196             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> r;
<a name="l00197"></a>00197             ToAngleAxis ( rkAxis, r );
<a name="l00198"></a>00198             rfAngle = r;
<a name="l00199"></a>00199         }
<a name="l00200"></a>00200         <span class="keywordtype">void</span> FromAngleAxis (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fRadians);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202         <span class="comment">// The matrix must be orthonormal.  The decomposition is yaw*pitch*roll</span>
<a name="l00203"></a>00203         <span class="comment">// where yaw is rotation about the Up vector, pitch is rotation about the</span>
<a name="l00204"></a>00204         <span class="comment">// Right axis, and roll is rotation about the Direction axis.</span>
<a name="l00205"></a>00205         <span class="keywordtype">bool</span> ToEulerAnglesXYZ (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfYAngle, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfPAngle,
<a name="l00206"></a>00206             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfRAngle) <span class="keyword">const</span>;
<a name="l00207"></a>00207         <span class="keywordtype">bool</span> ToEulerAnglesXZY (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfYAngle, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfPAngle,
<a name="l00208"></a>00208             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfRAngle) <span class="keyword">const</span>;
<a name="l00209"></a>00209         <span class="keywordtype">bool</span> ToEulerAnglesYXZ (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfYAngle, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfPAngle,
<a name="l00210"></a>00210             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfRAngle) <span class="keyword">const</span>;
<a name="l00211"></a>00211         <span class="keywordtype">bool</span> ToEulerAnglesYZX (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfYAngle, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfPAngle,
<a name="l00212"></a>00212             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfRAngle) <span class="keyword">const</span>;
<a name="l00213"></a>00213         <span class="keywordtype">bool</span> ToEulerAnglesZXY (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfYAngle, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfPAngle,
<a name="l00214"></a>00214             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfRAngle) <span class="keyword">const</span>;
<a name="l00215"></a>00215         <span class="keywordtype">bool</span> ToEulerAnglesZYX (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfYAngle, <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfPAngle,
<a name="l00216"></a>00216             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfRAngle) <span class="keyword">const</span>;
<a name="l00217"></a>00217         <span class="keywordtype">void</span> FromEulerAnglesXYZ (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fYAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fPAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fRAngle);
<a name="l00218"></a>00218         <span class="keywordtype">void</span> FromEulerAnglesXZY (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fYAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fPAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fRAngle);
<a name="l00219"></a>00219         <span class="keywordtype">void</span> FromEulerAnglesYXZ (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fYAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fPAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fRAngle);
<a name="l00220"></a>00220         <span class="keywordtype">void</span> FromEulerAnglesYZX (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fYAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fPAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fRAngle);
<a name="l00221"></a>00221         <span class="keywordtype">void</span> FromEulerAnglesZXY (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fYAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fPAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fRAngle);
<a name="l00222"></a>00222         <span class="keywordtype">void</span> FromEulerAnglesZYX (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fYAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fPAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fRAngle);
<a name="l00224"></a>00224         <span class="keywordtype">void</span> EigenSolveSymmetric (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afEigenvalue[3],
<a name="l00225"></a>00225             <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> akEigenvector[3]) <span class="keyword">const</span>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227         <span class="keyword">static</span> <span class="keywordtype">void</span> TensorProduct (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkU, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkV,
<a name="l00228"></a>00228             <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rkProduct);
<a name="l00229"></a>00229 
<a name="l00231"></a><a class="code" href="classOgre_1_1Matrix3.html#af631455ebc8569768f1afb7a8711bca7">00231</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> hasScale()<span class="keyword"> const</span>
<a name="l00232"></a>00232 <span class="keyword">        </span>{
<a name="l00233"></a>00233             <span class="comment">// check magnitude of column vectors (==local axes)</span>
<a name="l00234"></a>00234             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t = m[0][0] * m[0][0] + m[1][0] * m[1][0] + m[2][0] * m[2][0];
<a name="l00235"></a>00235             <span class="keywordflow">if</span> (!<a class="code" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(t, 1.0, (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)1e-04))
<a name="l00236"></a>00236                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00237"></a>00237             t = m[0][1] * m[0][1] + m[1][1] * m[1][1] + m[2][1] * m[2][1];
<a name="l00238"></a>00238             <span class="keywordflow">if</span> (!<a class="code" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(t, 1.0, (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)1e-04))
<a name="l00239"></a>00239                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00240"></a>00240             t = m[0][2] * m[0][2] + m[1][2] * m[1][2] + m[2][2] * m[2][2];
<a name="l00241"></a>00241             <span class="keywordflow">if</span> (!<a class="code" href="classOgre_1_1Math.html#a890336e0e4b6914024bfefd79c08f432" title="Compare 2 reals, using tolerance for inaccuracies.">Math::RealEqual</a>(t, 1.0, (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)1e-04))
<a name="l00242"></a>00242                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00245"></a>00245         }
<a name="l00246"></a>00246 
<a name="l00249"></a>00249         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00250"></a><a class="code" href="classOgre_1_1Matrix3.html#ab1f3df74a0e5f9db6bdede953974466b">00250</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; mat )
<a name="l00251"></a>00251         {
<a name="l00252"></a>00252             o &lt;&lt; <span class="stringliteral">&quot;Matrix3(&quot;</span> &lt;&lt; mat[0][0] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; mat[0][1] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; mat[0][2] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> 
<a name="l00253"></a>00253                             &lt;&lt; mat[1][0] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; mat[1][1] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; mat[1][2] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> 
<a name="l00254"></a>00254                             &lt;&lt; mat[2][0] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; mat[2][1] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; mat[2][2] &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00255"></a>00255             <span class="keywordflow">return</span> o;
<a name="l00256"></a>00256         }
<a name="l00257"></a>00257 
<a name="l00258"></a><a class="code" href="classOgre_1_1Matrix3.html#a5bf17bf2239af2516e359dc6de22bf3d">00258</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Matrix3.html#a5bf17bf2239af2516e359dc6de22bf3d">EPSILON</a>;
<a name="l00259"></a><a class="code" href="classOgre_1_1Matrix3.html#a4561d62d4d2c088ce2a3b6c3ec3d09af">00259</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> <a class="code" href="classOgre_1_1Matrix3.html#a4561d62d4d2c088ce2a3b6c3ec3d09af">ZERO</a>;
<a name="l00260"></a><a class="code" href="classOgre_1_1Matrix3.html#adcb2945d4f9b8995236be5a27dcfe343">00260</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a> <a class="code" href="classOgre_1_1Matrix3.html#adcb2945d4f9b8995236be5a27dcfe343">IDENTITY</a>;
<a name="l00261"></a>00261 
<a name="l00262"></a>00262     <span class="keyword">protected</span>:
<a name="l00263"></a>00263         <span class="comment">// support for eigensolver</span>
<a name="l00264"></a>00264         <span class="keywordtype">void</span> Tridiagonal (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afDiag[3], <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afSubDiag[3]);
<a name="l00265"></a>00265         <span class="keywordtype">bool</span> QLAlgorithm (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afDiag[3], <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afSubDiag[3]);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267         <span class="comment">// support for singular value decomposition</span>
<a name="l00268"></a><a class="code" href="classOgre_1_1Matrix3.html#aa4db0a7f3f09a72d78b602639c3d8af5">00268</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Matrix3.html#aa4db0a7f3f09a72d78b602639c3d8af5">msSvdEpsilon</a>;
<a name="l00269"></a><a class="code" href="classOgre_1_1Matrix3.html#a5e4a7f79f1b639102b04410b232702c6">00269</a>         <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Matrix3.html#a5e4a7f79f1b639102b04410b232702c6">msSvdMaxIterations</a>;
<a name="l00270"></a>00270         <span class="keyword">static</span> <span class="keywordtype">void</span> Bidiagonalize (<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kA, <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kL,
<a name="l00271"></a>00271             <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kR);
<a name="l00272"></a>00272         <span class="keyword">static</span> <span class="keywordtype">void</span> GolubKahanStep (<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kA, <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kL,
<a name="l00273"></a>00273             <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kR);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275         <span class="comment">// support for spectral norm</span>
<a name="l00276"></a>00276         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> MaxCubicRoot (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> afCoeff[3]);
<a name="l00277"></a>00277 
<a name="l00278"></a><a class="code" href="classOgre_1_1Matrix3.html#afa4cf13c54bdcc2df5fa761e01ad180d">00278</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> m[3][3];
<a name="l00279"></a>00279 
<a name="l00280"></a>00280         <span class="comment">// for faster access</span>
<a name="l00281"></a><a class="code" href="classOgre_1_1Matrix3.html#aed2829d86d2df8f9333d4c0087455880">00281</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>;
<a name="l00282"></a>00282     };
<a name="l00285"></a>00285 }
<a name="l00286"></a>00286 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
